﻿package org.highangle.ui
{
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.utils.getQualifiedClassName;
	
	/**
	 * ...
	 * @author kakyoin
	 */
	public class TabPanel extends Sprite
	{
		private var panelList:Array = new Array();
		private var _width:Number = 200;
		private var _height:Number = 200;
		private var totalTabWidth:Number = 0;
		private var bgcolor:uint;
		
		public function TabPanel(width:int = 200, height:int=200, clr:uint = 0xd0d0d0):void 
		{
			bgcolor = clr;
			setSize(width, height);
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		public function addPanel(content:DisplayObject, pn:String = ''):void
		{
			var tr:Panel = new Panel(pn, totalTabWidth, bgcolor)
			tr.id = panelList.length;
			tr.content = content;
			
			panelList.push(tr);
			
			tr.addEventListener('TabClick', onTabClick);
			addChild(tr);
			totalTabWidth += tr.tabWidth + 8;
			
			clickPanel(panelList[0])
		}
		
		private function onTabClick(e:Event):void
		{
			if (getQualifiedClassName(e.currentTarget).indexOf("Panel"))
			{
				var id:int = e.currentTarget.id;
				clickPanel(panelList[id]);
			}
		}
		
		public function clickPanel(tr:Panel):void
		{
			setChildIndex(tr, numChildren - 1);
			
			for (var i:int = 0; i < panelList.length; i++) 
			{
				panelList[i].alpha = 0.5;
			}
			tr.alpha = 1;
		}
		
		public function getSize():Object
		{
			return { width:_width, height:_height };
		}
		
		public function setSize(w:Number = -1, h:Number = -1):void
		{
			_width = (w)? w : _width;
			_height = (h)? h : _height;
		}
		
		public function set cntentWidth(w:Number):void
		{
			_width = w;
		}
		
		public function set cntentHeight(h:Number):void
		{
			_height = h;
		}
		
		public function update():void
		{
			for (var i:String in panelList)
			{
				panelList[i].update();
			}
		}
		
	}
}

import adobe.utils.CustomActions;
import flash.display.DisplayObject;
import flash.display.GradientType;
import flash.display.Graphics;
import flash.display.Sprite;
import flash.events.Event;
import flash.events.MouseEvent;
import flash.filters.DropShadowFilter;
import flash.filters.GlowFilter;
import flash.filters.GradientGlowFilter;
import flash.text.TextField;
import org.highangle.ui.TabPanel;

class Panel extends Sprite
	{
		private var _pa:TabPanel;
		private var label:TextField;
		private var _name:String;
		private var bgcolor:uint = 0xd0d0d0;
		private var maskObj:Sprite; 
		private var hitAreaSp:Sprite;
		
		public var content:DisplayObject;
		public var id: int;
		public var tabWidth:Number = 0;
		public var tabHeight:Number = 28;
		
		public function Panel(pn:String, tabx:Number, clr:uint):void 
		{
			_name = pn;
			label = new TextField();
			label.selectable = false;
			label.text = _name;
			label.width = label.textWidth + 10;
			label.x = tabx + 4;
			label.y = 2;
			tabWidth = label.width;
			bgcolor = clr;
			//label.visible = false;
			
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void
		{
			hitAreaSp = new Sprite();
			hitAreaSp.alpha = 0;
			hitAreaSp.buttonMode = true;
			addChild(hitAreaSp);
			hitAreaSp.addEventListener(MouseEvent.CLICK, onClick);
			
			_pa = TabPanel(parent);
			addChild(label);
			update();
			
			filters = [new GlowFilter(0x808080, 1, 3, 3)];
			
			if (content)
			{
				content.x = 4;
				content.y = tabHeight + 4;
				addChild(content);
			}
		}
		
		private function onClick(e:Event):void
		{
			switch(e.currentTarget)
			{
				case hitAreaSp:
				{
					var e2:Event = new Event('TabClick');
					dispatchEvent(e2);
					e2 = null;
					break;
				}
			}
		}
		
		public function update():void
		{
			var g:Graphics = graphics;
			g.lineStyle(6, bgcolor, 1);
			g.beginFill(bgcolor);
			
			g.drawRect(label.x -4, 0, tabWidth, tabHeight );
			g.drawRect(0, tabHeight,  _pa.getSize().width,  _pa.getSize().height );
			g.endFill();
			
			removeChild(hitAreaSp);
			g = hitAreaSp.graphics;
			g.beginFill(0xff0000);
			g.drawRect(label.x -4, 0, tabWidth, tabHeight );
			g.endFill();
			addChild(hitAreaSp);
		}
	}